unit StatTlf;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Buttons, RXCtrls, Mask, ToolEdit, Db, Grids, DBGrids,
  RXDBCtrl, DBTables, RxQuery, RXSpin, ComCtrls;

type
  TFormStatist = class(TForm)
    PanelDopUsl: TPanel;
    cbTLF: TCheckBox;
    cbMoney: TCheckBox;
    RxSpinEdit1: TRxSpinEdit;
    CheckBoxOrg: TCheckBox;
    cbOrgan: TComboBox;
    ComboEdit1: TComboEdit;
    QueryTelOrg: TQuery;
    Label2: TLabel;
    Label1: TLabel;
    bnSerch: TBitBtn;
    BitBtn1: TBitBtn;
    PrBar: TProgressBar;
    DateEdit2: TMonthCalendar;
    DateEdit1: TMonthCalendar;
    procedure cbTLFClick(Sender: TObject);
    procedure cbMoneyClick(Sender: TObject);
    procedure bnSerchClick(Sender: TObject);
    procedure Execute;
    procedure CheckBoxOrgClick(Sender: TObject);
    procedure ComboEdit1ButtonClick(Sender: TObject);
    function TimeInt: integer;
  private
    procedure InitTime;
  public
    Tip_obr : word;
  end;

var
  FormStatist: TFormStatist;

implementation

{$R *.DFM}

uses TlfChr, VarRing, SpisTlf;

procedure TFormStatist.cbTLFClick(Sender: TObject);
begin
   ComboEdit1.Enabled :=  cbTLF.Checked;
   if cbTLF.Checked then CheckBoxOrg.Checked := False;
end;

procedure TFormStatist.cbMoneyClick(Sender: TObject);
begin
   RxSpinEdit1.Enabled :=  cbMoney.Checked;
end;

procedure TFormStatist.InitTime;
var Year, Month, Day : Word;
begin
   DecodeDate(Date, Year, Month, Day );
   DateEdit2.Date :=  StrToDate('01.'+IntToStr(Month)+'.'+IntToStr(Year));
   if Month > 1 then dec(Month)
                else begin Month := 12; Dec(Year)  end;
   DateEdit1.Date :=  StrToDate('01.'+IntToStr(Month)+'.'+IntToStr(Year));
end;

function TFormStatist.TimeInt: integer;
begin
   Tip_obr := 1;
   InitTime;
   PanelDopUsl.Visible := False;
   TimeInt := ShowModal;
end;

procedure TFormStatist.Execute;
begin
   Tip_obr := 0;
   InitTime;
   PanelDopUsl.Visible := True;
   with MainForm.TableExistOrg do  {    }
    begin Active := True;
          cbOrgan.Items.Clear;
          while not(EOF) do begin
            cbOrgan.Items.Add(Fields[0].AsString);
            Next           end;
         Active := False;
    end;
   ShowModal;
end;

procedure TFormStatist.bnSerchClick(Sender: TObject);
Label TlfNotBelong, TlfBelong;
Var I, NomTel : Integer;
    SumMoney : Extended;
begin
  MainForm.BeginDate := DateEdit1.Date;
  MainForm.EndDate := DateEdit2.Date;
  MainForm.QueryNewTel.First;
   With FormVarRing.VargTel do begin
    RowCount := MainForm.QueryNewTel.RecordCount +1;
    Cells[0,0] := ' ';
    Cells[1,0] := ' ';
    Cells[2,0] := '';
    Cells[3,0] := ' ( )';
    Cells[4,0] := ' .';
   end;
  If Tip_obr <> 0 then begin ModalResult := mrOK;
                             Exit            end;
  if CheckBoxOrg.Checked Then {   -}
   with QueryTelOrg do begin
   ParamByName('ORGAN').AsString := cbOrgan.Text;
   Active := True;
  end;
  NomTel := 0;   I := 0;   SumMoney := 0;
  PrBar.Max := MainForm.QueryNewTel.RecordCount;
  PrBar.Visible := True;
  with MainForm.QueryNewTel do
   While not(EOF) do begin  {  }
   If MainForm.TimeInt then begin { ????      }
    if cbTLF.Checked then begin
     if FieldByName('TLFMG').AsString <> ComboEdit1.Text then goto TlfNotBelong
                         end
    else if CheckBoxOrg.Checked Then begin {!!!     -}
     QueryTelOrg.First;
     while not(QueryTelOrg.EOF) do
       if QueryTelOrg.Fields[0].AsString = FieldByName('TLFMG').AsString
         then goto TlfBelong
         else QueryTelOrg.Next;
     goto TlfNotBelong              end; {!!!     -}
TlfBelong:  if (cbMoney.Checked) and {   }
            ( FieldByName('MONEY').AsCurrency < RxSpinEdit1.Value)
            then goto TlfNotBelong;
   FormVarRing.InsNomTel(NomTel,SumMoney); {      }
   end;      { ????      }
TlfNotBelong:  Next;
   Inc (I);  PrBar.Position := I;
   end;   {  }
   PrBar.Visible := False;
   QueryTelOrg.Active := False;
   If NomTel = 0 then begin
      ShowMessage('     ');
      ModalResult := mrNo;           Exit    end;
   FormVarRing.Execute( NomTel, SumMoney );
end;

procedure TFormStatist.CheckBoxOrgClick(Sender: TObject);
begin
   cbOrgan.Enabled :=  CheckBoxOrg.Checked;
   if CheckBoxOrg.Checked then cbTLF.Checked := False;
end;

procedure TFormStatist.ComboEdit1ButtonClick(Sender: TObject);
begin
  ComboEdit1.Text := FormTlf.Execute;
end;

end.
