unit TlfChr;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  SpeedBar, Menus, ExtCtrls, Db, DBTables, ComCtrls, Placemnt, Grids,
  RXCtrls, DBGrids;

type
  TMainForm = class(TForm)
    SpeedBar: TSpeedBar;
    MainMenu1: TMainMenu;
    N1: TMenuItem;
    SpeedbarSection1: TSpeedbarSection;
    siObrFile: TSpeedItem;
    mnObrFile: TMenuItem;
    mnClose: TMenuItem;
    N4: TMenuItem;
    SpeedItem1: TSpeedItem;
    N2: TMenuItem;
    AboutDesign: TMenuItem;
    N6: TMenuItem;
    OpenFileDialog: TOpenDialog;
    Database1: TDatabase;
    TableFile: TTable;
    N3: TMenuItem;
    mnDesign: TMenuItem;
    SpeedbarSection2: TSpeedbarSection;
    SiAbout: TSpeedItem;
    SpeedItem2: TSpeedItem;
    siDesign: TSpeedItem;
    FormStorage1: TFormStorage;
    N7: TMenuItem;
    SpeedbarSection3: TSpeedbarSection;
    SpeedItem3: TSpeedItem;
    mnNtlf: TMenuItem;
    siSpisKlient: TSpeedItem;
    mnSpisKlient: TMenuItem;
    Panel1: TPanel;
    PrBar: TProgressBar;
    QueryPovtTel: TQuery;
    mnTlfRing: TMenuItem;
    siTlfRing: TSpeedItem;
    TableExistOrg: TTable;
    Image: TImage;
    QueryNewTel: TTable;
    QueryExistTel: TTable;
    procedure mnObrFileClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure mnCloseClick(Sender: TObject);
    procedure AboutDesignClick(Sender: TObject);
    procedure mnDesignClick(Sender: TObject);
    procedure mnNtlfClick(Sender: TObject);
    procedure mnSpisKlientClick(Sender: TObject);
    procedure mnTlfRingClick(Sender: TObject);
    procedure N6Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    function TimeInt : boolean;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    BeginDate, EndDate : TDateTime;
  end;

var
  MainForm: TMainForm;

implementation

uses About, SpisAb, VarRing, StatTlf;
{$R *.DFM}

procedure TMainForm.mnObrFileClick(Sender: TObject);
Var Prom : string;
    I : Integer;  SumRazg, Spr : Extended;
begin  {       }
  if OpenFileDialog.Execute then begin
   Prom := OpenFileDialog.FileName;
   I := Length(Prom);
   while Prom[I] <> '\' do dec(I);
   TableFile.DatabaseName := Copy( Prom, 1, I );
   TableFile.TableName := Copy( Prom, I+1, Length(Prom)-I );
    TableFile.Active := True;
    {      }
    QueryPovtTel.ParamByName('TIMERING').AsDateTime :=
           StrToDateTime(TableFile.FieldByName('TALKDATE').AsString);
    QueryPovtTel.ParamByName('TLFMG').AsString := TableFile.FieldByName('ZIP').AsString;
    QueryPovtTel.Active := True;
    if QueryPovtTel.RecordCount <> 0 then
      begin  {      -  }
       QueryPovtTel.Active := False;
       TableFile.Active := False;
       ShowMessage('    -    ');
       Exit;
      end;
    QueryPovtTel.Active := False;
    PrBar.Max := TableFile.RecordCount;
    PrBar.Visible := True;
    QueryNewTel.Last;
    I := 0;    SumRazg := 0;
    While not(TableFile.EOF) do begin
      QueryNewTel.Insert;
      QueryNewTel.FieldByName('TLFMG').AsString := TableFile.FieldByName('ZIP').AsString;
      QueryNewTel.FieldByName('TLFTCHER').AsString :=
         Copy(TableFile.FieldByName('TELEFON').AsString, 2, 6);
      QueryNewTel.FieldByName('DLIT').AsFloat := TableFile.FieldByName('DLIT').AsFloat;
         Prom := TableFile.FieldByName('TALKDATE').AsString;
      QueryNewTel.FieldByName('TIMERING').AsDateTime := StrToDateTime(Prom);
      Spr := TableFile.FieldByName('SUMMA').AsFloat;
      SumRazg := SumRazg + Spr;
      QueryNewTel.FieldByName('MONEY').AsFloat := Spr;
      QueryNewTel.Post;
     Inc (I);    PrBar.Position := I;
     TableFile.Next;
    end;
  PrBar.Visible := False;
  TableFile.Active := False;
  Prom := FloatToStrF(SumRazg, ffCurrency, 16, 2);
  ShowMessage('    '+ IntTostr(I)+
              ' '#10#13'   '+ Prom);
end; end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
    {    }
  Session.GetAliasParams('TLFUCH', DataBase1.Params);
  Database1.Open;
  QueryNewTel.Active := True;
end;

procedure TMainForm.mnCloseClick(Sender: TObject);
begin
 Database1.Close;
 Close;
end;

procedure TMainForm.AboutDesignClick(Sender: TObject);
begin
   Application.CreateForm(TAboutBox, AboutBox);
   AboutBox.ShowModal;
   AboutBox.Release;
end;

procedure TMainForm.mnDesignClick(Sender: TObject);
begin
  Speedbar.Customize(0);
end;

function TMainForm.TimeInt: boolean;
  Var tempV :TDateTime;
begin     {      !!!}
  tempV := StrToDate(DateToStr(QueryNewTel.FieldByName('TIMERING').AsDateTime));
  if ( tempV < EndDate ) and (tempV > BeginDate )
     then TimeInt := True    else TimeInt := False
end;

procedure TMainForm.mnNtlfClick(Sender: TObject);
Label MomerExist;
Var I, NomTel : Integer;
    SumMoney : Extended;
begin {     }
   If FormStatist.TimeInt <> mrOK then Exit;  {      }
    {    }
   PrBar.Max := QueryNewTel.RecordCount;
   QueryNewTel.First;
   PrBar.Visible := True;
   NomTel := 0;   I := 0;   SumMoney := 0;
   QueryExistTel.Active := True;
   With QueryNewTel do while not(EOF) do
    begin {     }
     If TimeInt then begin { ????      }
      QueryExistTel.First;
      while not(QueryExistTel.EOF) do
      begin {         }
        if QueryExistTel.FieldByName('TELEFMG').AsString =
             FieldByName('TLFMG').AsString then goto MomerExist;
        QueryExistTel.Next;
      end;
    FormVarRing.InsNomTel(NomTel,SumMoney); {       }
   end;      { ????      }
MomerExist: Next;
    Inc (I);  PrBar.Position := I;
    end;
   PrBar.Visible := False;
   QueryExistTel.Active := False;
   If NomTel = 0 then begin
      ShowMessage('      ');
      ModalResult := mrNo;           Exit    end;
   FormVarRing.Execute( NomTel, SumMoney );
end;

procedure TMainForm.mnSpisKlientClick(Sender: TObject);
begin   {    }
  FormSpisKl.Execute;
end;

procedure TMainForm.mnTlfRingClick(Sender: TObject);
begin   {      }
  FormStatist.Execute;
end;

procedure TMainForm.N6Click(Sender: TObject);
begin
  Application.HelpCommand(HELP_CONTENTS, 8);
end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
  Application.HelpCommand(HELP_QUIT,0);
end;

procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  QueryNewTel.Active := False;
  Database1.Close;
end;

end.
